<template>
  <v-app id="inspire">
    <v-app-bar app clipped-right clipped-left>
      <v-img
        :src="require('../assets/logo_bps.png')"
        max-height="50"
        max-width="50"
        contain
      ></v-img>
      <v-toolbar-title> <h5>BPS</h5> </v-toolbar-title>
      <v-spacer></v-spacer>
      <v-toolbar-title> <h4>Smart Visualization</h4> </v-toolbar-title>
      <v-spacer></v-spacer>
      <v-app-bar-nav-icon @click="drawer = !drawer"></v-app-bar-nav-icon>
    </v-app-bar>

    <v-navigation-drawer
      v-model="drawer"
      app
      clipped
      right
      width="250"
      class="pa-2 fill-height"
    >
      <v-row align="center" class="mb-1 mt-2">
        <v-col class="py-0">
          <v-checkbox
            v-model="useBlockData"
            label="Use Block Data"
          ></v-checkbox>
        </v-col>
      </v-row>
      <v-row align="center" class="mb-1">
        <v-col class="py-0">
          <v-select
            :items="selectWilayah.listProv"
            v-model="selectWilayah.prov"
            menu-props="auto"
            hide-details
            label="Provinsi"
            single-line
            dense
            dark
            outlined
            class="select-text-color-1"
          ></v-select>
        </v-col>
      </v-row>
      <v-row align="center" class="mb-1">
        <v-col class="py-0">
          <v-select
            :items="selectWilayah.listKabKot"
            v-model="selectWilayah.kab"
            label="Kabupaten"
            menu-props="auto"
            hide-details
            single-line
            dense
            dark
            outlined
            class="select-text-color-1"
          ></v-select>
        </v-col>
      </v-row>
      <v-row style="text-align: left">
        <v-col v-if="selectWilayah.filterWilayah == ''">
          <v-alert outlined type="warning" prominent border="left"
            >Silahkan memilih wilayah terlebih dahulu</v-alert
          >
        </v-col>
      </v-row>
      <v-row>
        <v-col>
          <v-select
            :items="selectData.listTitle"
            v-on:change="titleChange(selectData.title)"
            v-model="selectData.title"
            label="Judul data"
            dense
            solo
            flat
            hide-details
            class="mb-1"
          ></v-select>
          <v-select
            :items="selectData.listVariabel"
            v-on:change="variableChange(selectData.variabel)"
            v-model="selectData.variabel"
            label="Variabel"
            dense
            solo
            hide-details
            class="mb-2"
          ></v-select>
          <v-select
            :items="selectData.listSeries"
            v-model="selectData.series"
            label="Series Data"
            dense
            solo
            hide-details
            class="mb-2"
          ></v-select>
          <v-btn
            :loading="showMapDataState == 1"
            :disabled="showMapDataState == 1"
            outlined
            rounded
            color="blue darken-2"
            dark
            block
            @click="showMapData()"
          >
            Tampilkan
            <v-icon>mdi-map-marker</v-icon>
          </v-btn>
        </v-col>
      </v-row>

      <v-row v-show="showMapDataState == 2">
        <v-col>
          <v-card>
            <p
              class="pa-2 mb-0"
              style="text-align: left; font-size: 16px"
              v-text="selectData.judulDeskripsi"
            ></p>
            <div id="legend"></div>
          </v-card>
        </v-col>
      </v-row>
      <v-row v-show="showMapDataState == 2">
        <v-col>
          <v-card>
            <v-container class="py-0">
              <v-row>
                <v-col md="3">
                  <v-slider
                    v-model="opacitySlider"
                    vertical
                    class="this-slider"
                    style="min-height: 100px"
                    height="100px"
                  >
                    <template v-slot:prepend>
                      <small>Tranparansi</small>
                    </template>
                  </v-slider>
                </v-col>
                <v-col md="6"> </v-col>
              </v-row>
            </v-container>
          </v-card>
        </v-col>
      </v-row>
    </v-navigation-drawer>

    <v-navigation-drawer
      app
      clipped
      left
      value="false"
      class="pa-2 fill-height"
    >
      <v-row align="center" class="mb-1 mt-6" v-if="dataLoaded">
        <PieChart :chart-data="pieChartData" />
      </v-row>
      <v-row align="center" class="mb-1 mt-6" v-if="dataLoaded">
        <BarChart :chart-data="barChartData" />
      </v-row>
    </v-navigation-drawer>

    <v-main>
      <v-container class="fill-height" fluid>
        <div id="app">
          <div id="map" style="height: 100%; width: 100%"></div>
        </div>
      </v-container>
    </v-main>

    <v-footer padless app>
      <v-col class="text-center" cols="12">
        {{ new Date().getFullYear() }} — <strong>PLTI Kelompok 2</strong>
      </v-col>
    </v-footer>
  </v-app>
</template>

<script>
import Map from "@arcgis/core/Map";
import MapView from "@arcgis/core/views/MapView";
import esriId from "@arcgis/core/identity/IdentityManager";
import Compass from "@arcgis/core/widgets/Compass";
import BasemapGallery from "@arcgis/core/widgets/BasemapGallery";
import Expand from "@arcgis/core/widgets/Expand";
import ScaleBar from "@arcgis/core/widgets/ScaleBar";
import Home from "@arcgis/core/widgets/Home";
import FeatureLayer from "@arcgis/core/layers/FeatureLayer";
// import Query from "@arcgis/core/rest/support/Query";

import GeoJSONLayer from "@arcgis/core/layers/GeoJSONLayer";
import classBreaks from "@arcgis/core/smartMapping/statistics/classBreaks";
import * as colorSchemes from "@arcgis/core/smartMapping/symbology/color";

import PieChart from "../components/Pie.vue";
import BarChart from "../components/Bar.vue";

import axios from "axios";
import chroma from "chroma-js";

export default {
  components: {
    PieChart,
    BarChart,
  },
  data() {
    return {
      useBlockData: false,
      dataLoaded: false,
      barChartData: {
        labels: [],
        datasets: [
          {
            label: "Bar Chart",
            backgroundColor: "#3787c0",
            data: [],
          },
        ],
      },
      pieChartData: {
        labels: [],
        datasets: [
          {
            backgroundColor: [],
            data: [],
          },
        ],
      },
      drawer: null,
      shareConf: {
        url: "https://geoportal.bps.go.id",
        title: "WebGis Potensi Desa 2018",
        description: "Visualisasi hasil pendataan Potensi Desa Tahun 2018",
        quote: "WebGis Potensi Desa 2018",
        hashtags: "sig_bps",
      },
      taDialog: true,
      rightDrawer: false,
      showInfraDialog: false,
      showFooter: false,
      loading: false,
      titikInfrasActive: [],
      opacitySlider: 100,
      showMapDataState: 0,
      alert: { show: false, title: "", messages: "" },
      searchWilayah: {
        entries: [],
        isLoading: false,
        model: null,
        search: null,
      },
      selectWilayah: {
        filterWilayah: "",
        prov: "",
        provText: "",
        kab: "",
        kabKotText: "",
        kec: "",
        kecText: "",
        listProv: [],
        listKabKot: [],
        listKec: [],
      },
      selectData: {
        title: "",
        titleText: "",
        variabel: "",
        variabelText: "",
        series: "",
        seriesText: "",
        deskripsi: "",
        konsep_definisi: "",
        listTitle: [],
        listVariabel: [],
        listSeries: [],
        dataCell: {},
        judulDeskripsi: "",
        variabelType: "",
      },
      chartData: null,
      chartProps: {
        responsive: true,
        maintainAspectRatio: false,
        legend: {
          display: false,
        },
        title: {
          display: true,
          fontColor: "#fcd821",
          text: "Custom Chart Title",
        },
        scales: {
          yAxes: [
            {
              display: false,
            },
          ],
        },
      },
      featuresChart: null,
      mapProps: {
        map: null,
        view: null,
        provLayer: null,
        kabkotLayer: null,
        highlightGraphic: null,
        // legend: null
      },
      selectedColor: "blues",
      defaultColorBrewer: {
        // blues: chroma.scale('blues').colors(25),
        // greens: chroma.scale('greens').colors(25),
        // oranges: chroma.scale('oranges').colors(25)
      },
    };
  },
  watch: {
    "selectWilayah.prov": function (val) {
      this.provChange(val);
    },

    "selectWilayah.kab": function (val) {
      this.kabChange(val);
    },
    useBlockData: function () {
      this.fetchDataTitle();
    },
  },
  mounted() {
    this.fetchProvinsi();
    this.fetchDataTitle();

    this.refreshToken();
  },
  created() {
    this.$vuetify.theme.dark = true;
  },
  methods: {
    urlBlockPath: function () {
      return this.useBlockData==true ? "/blockchain/" : "/";
    },
    refreshToken: function () {
      fetch(
        "https://sig.bps.go.id/geoportal-api-management/api/token/id/1b5e076b-cc6b-43fc-8bb6-a306d03e001b"
      )
        .then((res) => res.json())
        .then((res) => {
          console.log(res);
          const token = res.token;
          esriId.registerToken({
            server: "https://geoportal.bps.go.id/server/rest/services",
            token: token,
            ssl: false,
          });
          this.initMap();
        });
      //
    },
    initMap: function () {
      this.shareConf.url = window.location.href;

      //map
      this.mapProps.map = new Map({
        basemap: "topo-vector",
      });

      this.mapProps.view = new MapView({
        container: "map",
        map: this.mapProps.map,
        center: [117.805, 1.16], // longitude, latitude
        zoom: 5,
      });

      // new CustomLegend({
      //   container: "legend",
      //   view: this.mapProps.view,
      // });

      const compassWidget = new Compass({
        view: this.mapProps.view,
      });
      const basemapGallery = new BasemapGallery({
        view: this.mapProps.view,
        container: document.createElement("div"),
      });

      const bgExpand = new Expand({
        view: this.mapProps.view,
        content: basemapGallery,
      });
      // Add widget to the top right corner of the view
      this.mapProps.view.ui.add(bgExpand, {
        position: "top-right",
      });

      const scaleBar = new ScaleBar({
        view: this.mapProps.view,
        unit: "metric",
        style: "ruler",
      });
      // Add widget to the bottom left corner of the view
      this.mapProps.view.ui.add(scaleBar, {
        position: "bottom-left",
      });

      // Add the Compass widget to the top left corner of the view
      this.mapProps.view.ui.add(compassWidget, "top-left");

      var homeWidget = new Home({
        view: this.mapProps.view,
      });

      // adds the home widget to the top left corner of the MapView
      this.mapProps.view.ui.add(homeWidget, "top-left");

      this.buildMapByUrlParams();
    },
    buildMapByUrlParams: function () {
      const indexOf = window.location.href.indexOf("?");
      if (indexOf < 0) return;
      const strUrlParams = window.location.href.substr(indexOf + 1);
      const ps = strUrlParams.split("&");
      if (ps.length == 0) return;
      const urlParams = {};
      for (let i = 0; i < ps.length; i++) {
        const pk = ps[i].split("=");
        urlParams[pk[0]] = pk[1];
      }
      this.selectWilayah.filterWilayah = urlParams.kodeWilayah;
      this.selectData.variabel = urlParams.selectData;
      this.showMapData();
    },
    fetchProvinsi: function () {
      axios.defaults.baseURL =
        process.env.NODE_ENV === "development"
          ? "http://localhost/plti_smart_data/dataapi/public/"
          : window.location.protocol +
            "//" +
            window.location.host +
            "/plti_smart_data/dataapi/public/";

      // Important: If axios is used with multiple domains, the AUTH_TOKEN will be sent to all of them.
      // See below for an example using Custom instance defaults instead.
      axios.defaults.headers.common["Authorization"] =
        "Bearer lb3psYExx699rZayerhDne07ahjfZEbr";

      axios.get("/api/master/wilayah/provinsi").then((response) => {
        // handle success
        console.log(response);
        this.selectWilayah.listProv.push({
          value: "62",
          text: "INDONESIA",
        });
        response.data.map((item) => {
          this.selectWilayah.listProv.push({
            value: item.kode,
            text: item.nama,
          });
        });
        // this.selectWilayah.listProv.sort((a, b) => {
        //   return parseInt(a.value) - parseInt(b.value);
        // });
        console.log(this.selectWilayah.listProv);
      });
    },

    provChange: function (v) {
      this.selectWilayah.filterWilayah = v;
      this.selectWilayah.listKabKot = [];

      for (let i = 0; i < this.selectWilayah.listProv.length; i++) {
        if (this.selectWilayah.listProv[i].value == v)
          this.selectWilayah.provText = this.selectWilayah.listProv[i].text;
      }

      this.loading = true;

      axios.get("/api/master/wilayah/kabkot/" + v).then((response) => {
        // handle success
        console.log(response);
        response.data.map((item) => {
          this.selectWilayah.listKabKot.push({
            value: item.kode,
            text: item.nama,
          });
        });
        this.selectWilayah.listKabKot.sort((a, b) => {
          return parseInt(a.value) - parseInt(b.value);
        });
        console.log(this.selectWilayah.listKabKot);
        this.loading = false;
      });
    },

    fetchDataTitle: function () {
      this.loading = true;

      axios
        .get("/api" + this.urlBlockPath() + "data/title")
        .then((response) => {
          // handle success
          console.log(response);
          this.selectData.listTitle=[];
          response.data.map((item) => {
            this.selectData.listTitle.push({
              value: item.id,
              text: item.short_title_id,
              deskripsi: item.description_id,
            });
          });
          // this.selectWilayah.listKabKot.sort((a, b) => {
          //   return parseInt(a.value) - parseInt(b.value);
          // });
          // console.log(this.selectWilayah.listKabKot);
          // this.loading = false;
        });
    },
    titleChange: function (v) {
      for (let i = 0; i < this.selectData.listTitle.length; i++) {
        if (this.selectData.listTitle[i].value == v)
          this.selectData.titleText = this.selectData.listTitle[i].text;
      }

      axios
        .get("/api" + this.urlBlockPath() + "data/title/detail/" + v)
        .then((response) => {
          // handle success
          console.log(response);
          response.data.map((item) => {
            this.selectData.listVariabel.push({
              value: item.id,
              text: item.var_name,
            });
          });
        });
    },
    variableChange: function (v) {
      axios
        .get("/api" + this.urlBlockPath() + "data/series/" + v)
        .then((response) => {
          // handle success
          console.log(response);
          response.data.map((item) => {
            console.log(item);
            this.selectData.listSeries.push({
              value: item.id,
              text: item.periode_value + " " + item.year,
            });
          });
        });
    },
    showMapData: function () {
      axios
        .get(
          "/api" + this.urlBlockPath() + "data/cell/" + this.selectData.series
        )
        .then((response) => {
          // handle success
          this.dataLoaded = true;
          let label = [];
          let chartdata = [];

          response.data.map((item) => {
            this.selectData.dataCell[item.row_key] = item;
            label.push(item.row_key);
            chartdata.push(item.cell_value);
          });

          this.barChartData.labels = label;
          this.barChartData.datasets[0].label = "Bar Chart";
          this.barChartData.datasets[0].data = chartdata;

          console.log(this.selectData.dataCell);

          this.loadMap();
        });
    },
    loadMap: function () {
      const geojsonlayer = new GeoJSONLayer({
        url: "prov.geojson",
        copyright: "BPS",
      });
      // this.mapProps.map.add(geojsonlayer); // adds the layer to the map

      geojsonlayer.queryFeatures().then((results) => {
        // prints the array of result graphics to the console

        results.features.map((item) => {
          console.log(item);
          item.attributes["data_value"] =
            this.selectData.dataCell[item.attributes["idprov"]].cell_value;
          // features.push({

          // });
        });
        console.log(results.features);
        const colorScheme = colorSchemes.getSchemes({
          basemap: this.mapProps.map.basemap,
          geometryType: "polygon",
          theme: "extremes",
          basemapTheme: "dark",
        });
        const primaryScheme = colorScheme.primaryScheme;
        this.mapProps.provLayer = new FeatureLayer({
          fields: [
            {
              name: "idprov",
              type: "string",
            },
            {
              name: "provinsi",
              type: "string",
            },
            {
              name: "data_value",
              type: "double",
            },
          ],
          objectIdField: "idprov",
          source: results.features, //  an array of graphics with geometry and attributes
          popupTemplate: {
            content:
              this.selectData.titleText +
              " pada {provinsi} sebesar {data_value}",
          },
          renderer: {
            type: "class-breaks", // autocasts as new ClassBreaksRenderer()
            field: this.selectData.variabel,
            // normalizationField: '',
            // legendOptions: {
            //     title: '% of adults (25+) with a college degree'
            // },
            defaultSymbol: {
              type: "simple-fill", // autocasts as new SimpleFillSymbol()
              color: primaryScheme.noDataColor,
              outline: primaryScheme.outline,
            },
          },
        });
        this.mapProps.map.add(this.mapProps.provLayer);

        classBreaks({
          layer: this.mapProps.provLayer,
          field: "data_value",
          classificationMethod: "natural-breaks",
          numClasses: 4,
        }).then((response) => {
          // class break infos that may be passed to the
          // constructor of a ClassBreaksRenderer
          let breakInfos = response.classBreakInfos;
          this.createRendererInfosSymbols(breakInfos, this.selectedColor);
          const renderer = {
            type: "class-breaks",
            field: "data_value",
            classBreakInfos: breakInfos,
          };
          this.mapProps.provLayer.renderer = renderer;

          console.log(breakInfos);
          let chartLabel = [];
          let chartBC = [];
          let chartData = [];
          for (let i = 0; i < breakInfos.length; i++) {
            chartData[i] = 0;
            const bi = breakInfos[i];
            let dt = this.barChartData.datasets[0].data;
            for (let j = 0; j < dt.length; j++) {
              if (dt[j] >= bi.minValue && dt[j] < bi.maxValue) {
                chartData[i] = chartData[i] + 1;
              }
            }
            chartLabel[i] = bi.label;
            chartBC[i] = bi.symbol.color;
          }
          this.pieChartData.labels = chartLabel;
          this.pieChartData.datasets[0].backgroundColor = chartBC;
          this.pieChartData.datasets[0].data = chartData;
        });
      });
    },
    createRendererInfosSymbols: function (infos, color) {
      const colors = chroma.scale(color).colors(infos.length);
      for (let i = 0; i < infos.length; i++) {
        infos[i].symbol = {
          type: "simple-fill", // autocasts as new SimpleFillSymbol()
          color: colors[i],
          style: "solid",
          outline: {
            // autocasts as new SimpleLineSymbol()
            color: [189, 189, 189, 0.5],
            width: 0.1,
          },
        };
      }
    },
  },
};
</script>

<style>
@import url("https://js.arcgis.com/4.23/@arcgis/core/assets/esri/themes/light/main.css");
html,
body {
  margin: 0;
  padding: 0;
  height: 100%;
  width: 100%;
}
#app {
  display: flex;
  flex-direction: column;
  padding: 0;
  margin: 0;
  width: 100%;
  height: 100%;
}
</style>
